   --      LibGrp_2.hs
   --      
   --------------------------------------------
   import LibGrp_2

   test =   testPairLis && testReKey && testReData && testAssoc1 
         && testRAssoc && testPutAssoc1 && testAddArc 
         && testDeleteNode && testDeleteArc && testWalk 
         && testNeighb2 && testOneRange && testListSet && testAssoc                         
   -----------------------------------------------------------------       
   testPairLis =   pairLis [1] [] [(2,[22,222])] == [(2,[22,222])]
                && pairLis [] [[4,5]] [(2,[22,222])] 
                      == [(2,[22,222])]
                && pairLis [1,2] [[5,6],[7]] [] 
                      == [(1,[5,6]),(2,[7])]
                && pairLis [1,2] [[5,6],[7]] 
                                 [(3,[33,333]),(4,[44,444])]
                      == [(1,[5,6]),(2,[7]),
                                    (3,[33,333]),(4,[44,444])]
                && pairLis [1,2] [[5,6],[]] 
                                 [(3,[-3,-33]),(2,[-2,-22])] 
                      == [(1,[5,6]),(3,[-3,-33]),(2,[-2,-22])]
                && pairLis [1,2] [[5,6],[4]] 
                                 [(3,[-3,-33]),(2,[-2,-22])] 
                      == [(1,[5,6]),(3,[-3,-33]),(2,[4,-2,-22])]
                && pairLis [1,2] [[5,6],[4]] 
                                 [(3,[-3,-33]),(2,[4,-22])]
                      == [(1,[5,6]),(3,[-3,-33]),(2,[4,-22])]
                && pairLis [1,2] [[5,6],[4]] 
                                 [(1,[2,5]),(2,[4,-2])]
                      == [(1,[6,2,5]),(2,[4,-2])]
   ----------------------------------------------------
   testReKey =   reKey []                         == []
              && reKey [(5,[])]                   == [5]
              && reKey [(1,[2,3])]                == [1]
              && reKey [(1,[5,6]),(5,[5,6])]      == [1,5]
              && reKey [(1,[5,6]),(2,[3]),(4,[])] == [1,2,4]
   ---------------------------------------------------------             
   testReData =   reData []                    == []
               && reData [(10,[])]             == [[]]
               && reData [(1,[2,3])]           == [[2,3]]
               && reData [(1,[5,6]),(5,[5,6])] == [[5,6],[5,6]]
               && reData [(1,[5,6]),(2,[3]),(4,[])] 
                                               == [[5,6],[3],[]]
   -------------------------------------------------------------     
   testAssoc1 =   assoc1 2 []                         == []
               && assoc1 10 [(10,[])]                 == []
               && assoc1 1 [(1,[2,3])]                == [2,3]
               && assoc1 5 [(1,[5,6]),(5,[5,6])]      == [5,6]
               && assoc1 2 [(1,[5,6]),(2,[3]),(4,[])] == [3]
   ---------------------------------------------------------             
   testRAssoc =   rAssoc [2,3] [(1,[2,3])]           == [1]
               && rAssoc [2,3] []                    == []
               && rAssoc [5,6] [(1,[5,6]),(4,[5,6])] == [1]
               && rAssoc [6,7] [(1,[7,6]),(4,[5,6])] == [1]
   --------------------------------------------------------              
   testPutAssoc1 =   putAssoc1 1 [2] [] == []
                  && putAssoc1 1 [10] [(1,[])]  
                                 == [(1,[10])]
                  && putAssoc1 2 [3,4,5] [(1,[2,3,4])] 
                                 == [(1,[2,3,4])]
                  && putAssoc1 1 [3,4,5] [(1,[2,3,4])] 
                                 == [(1,[3,4,5])]
                  && putAssoc1 3 [5,6] [(1,[2,3,4]),(2,[3]),(3,[])] 
                                 == [(1,[2,3,4]),(2,[3]),(3,[5,6])]
   ----------------------------------------------------------------    
   testAddArc =   addArc 1 2 [] == [(1,[2])]
               && addArc 1 5 [(1,[2,3,4])] == [(1,[5,2,3,4])]
               && addArc 1 2 [(1,[2,3,4])] == [(1,[2,3,4])]
               && addArc 2 1 [(1,[2,3,4])] == [(1,[2,3,4]),(2,[1])]
               && addArc 5 8 [(1,[2,3,4]),(5,[])] 
                                           == [(1,[2,3,4]),(5,[8])]
   ----------------------------------------------------------------     
   testDeleteNode =   deleteNode 2 []        == []
                   && deleteNode 1 [(1,[])]  == []
                   && deleteNode 2 [(2,[3])] == []
                   && deleteNode 3 [(1,[2,3,4]),(2,[3]),(3,[4])]
                                             == [(1,[2,4]),(2,[])]
                   && deleteNode 4 [(2,[4,3]),(4,[2,3])]
                                             == [(2,[3])]
   ------------------------------------------------------     
   testDeleteArc =   deleteArc 1 2 []          == []
                  && deleteArc 2 3 [(2,[3])]   == [(2,[])]
                  && deleteArc 2 3 [(1,[2,3,4]),(2,[3]),(3,[4])]
                                               == [(1,[2,3,4]),
                                                   (2,[]),(3,[4])]
                  && deleteArc 2 3 [(2,[2,3])] == [(2,[2])]
                  && deleteArc 4 3 [(2,[2,3]),(4,[2,3])]
                                               == [(2,[2,3]),
                                                   (4,[2])]
   --------------------------------------------------------     
   testWalk =   walk []       == []
             && walk [(1,[])] == [1]
             && walk [(1,[2,3,4]),(5,[6,7]),(8,[9])] 
                              == [1,2,3,4,5,6,7,8,9]
             && walk [(1,[2,3,4]),(2,[3]),(3,[4])]    == [1,2,3,4]
             && walk [(1,[2,3,4]),(2,[]),(3,[4,3,2])] == [1,2,3,4]
   ---------------------------------------------------------------       
   testNeighb2 =   neighb2 1 [(1,[2,3,4]),(2,[1,3]),(3,[1,2]),             
                                         (4,[1])] == [2,3,4]
                && neighb2 2 [(1,[2,3,4]),(2,[1,3]),(3,[1,2]),             
                                         (4,[1])] == [1,3]
                && neighb2 3 [(1,[2,3,4]),(2,[1,3]),(3,[1]),               
                                         (4,[1])] == [1]
                && neighb2 2 [(1,[2,3,4]),(2,[])] == []
                && neighb2 5 [(1,[2,3]),(2,[1,3]),(3,[1,2])] == []
   ---------------------------------------------------------------       
   -- "" 
   -------------------------------------------------
   testListSet =   listSet []                  == []
                && listSet [1]                 == [1]
                && listSet [1,1,1]             == [1]
                && listSet [1,2,3,3,2,1]       == [3,2,1]
                && listSet [1,1,2,3,2,3,1,2,1] == [3,2,1]
   ------------------------------------------------------                
   testOneRange =   oneRange []       == []
                 && oneRange [(1,[])] == [1]
                 && oneRange [(1,[]),(2,[]),(3,[])] 
                                      == [1,2,3]
                 && oneRange [(1,[-1]),(2,[]),(3,[-3,-33,33])] 
                                      == [1,-1,2,3,-3,-33,33]
   ----------------------------------------------------------     
   testAssoc =   assoc 2 [(1,[3])] (==) == []
              && assoc 2 [(11,[3,2]),(-2,[4,3,2,1]),(1,[2,1])] (<) 
                                        == [(-2,[4,3,2,1])]
              && assoc 2 [(1,[3,-1]),(-2,[]),(2,[1,0,-1])] (==) 
                                        == [(2,[1,0,-1])]
              && assoc (-22) [(-22,[]),(1,[2,2])] (<=) 
                                        == [(-22,[])]
              && assoc (-22) [(-22,[4]),(1,[2]),(2,[1])] (>) 
                                        == [(1,[2])]                                                                     
